Index: uspace/srv/hid/console/console.c
===================================================================
--- uspace/srv/hid/console/console.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/hid/console/console.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2011 Martin Decky
  * All rights reserved.
@@ -62,5 +63,5 @@
 typedef struct {
 	atomic_flag refcnt;      /**< Connection reference count */
-	prodcons_t input_pc;  /**< Incoming keyboard events */
+	prodcons_t input_pc;  /**< Incoming console events */
 
 	/**
@@ -79,4 +80,8 @@
 	console_caps_t ccaps;  /**< Console capabilities */
 
+	sysarg_t ucols;		/**< Number of columns in user buffer */
+	sysarg_t urows;		/**< Number of rows in user buffer */
+	charfield_t *ubuf;	/**< User buffer */
+
 	chargrid_t *frontbuf;    /**< Front buffer */
 	frontbuf_handle_t fbid;  /**< Front buffer handle */
@@ -94,4 +99,14 @@
 static sysarg_t cols;
 static sysarg_t rows;
+
+/** Mouse pointer X coordinate */
+static int pointer_x;
+/** Mouse pointer Y coordinate */
+static int pointer_y;
+/** Character under mouse cursor */
+static charfield_t pointer_bg;
+
+static int mouse_scale_x = 4;
+static int mouse_scale_y = 8;
 
 /** Array of data for virtual consoles */
@@ -135,4 +150,8 @@
 static void cons_set_cursor_visibility(con_srv_t *, bool);
 static errno_t cons_get_event(con_srv_t *, cons_event_t *);
+static errno_t cons_map(con_srv_t *, sysarg_t, sysarg_t, charfield_t **);
+static void cons_unmap(con_srv_t *);
+static void cons_buf_update(con_srv_t *, sysarg_t, sysarg_t, sysarg_t,
+    sysarg_t);
 
 static con_ops_t con_ops = {
@@ -151,6 +170,12 @@
 	.set_rgb_color = cons_set_rgb_color,
 	.set_cursor_visibility = cons_set_cursor_visibility,
-	.get_event = cons_get_event
+	.get_event = cons_get_event,
+	.map = cons_map,
+	.unmap = cons_unmap,
+	.update = cons_buf_update
 };
+
+static void pointer_draw(void);
+static void pointer_undraw(void);
 
 static console_t *srv_to_console(con_srv_t *srv)
@@ -219,4 +244,5 @@
 
 	fibril_mutex_lock(&switch_mtx);
+	pointer_undraw();
 
 	if (cons == active_console) {
@@ -227,7 +253,85 @@
 	active_console = cons;
 
+	pointer_draw();
 	fibril_mutex_unlock(&switch_mtx);
 
 	cons_damage(cons);
+}
+
+/** Draw mouse pointer. */
+static void pointer_draw(void)
+{
+	charfield_t *ch;
+	int col, row;
+
+	/* Downscale coordinates to text resolution */
+	col = pointer_x / mouse_scale_x;
+	row = pointer_y / mouse_scale_y;
+
+	/* Make sure they are in range */
+	if (col < 0 || row < 0 || col >= (int)cols || row >= (int)rows)
+		return;
+
+	ch = chargrid_charfield_at(active_console->frontbuf, col, row);
+
+	/*
+	 * Store background attributes for undrawing the pointer.
+	 * This is necessary as styles cannot be inverted with
+	 * round trip (unlike RGB or INDEX)
+	 */
+	pointer_bg = *ch;
+
+	/* In general the color should be a one's complement of the background */
+	if (ch->attrs.type == CHAR_ATTR_INDEX) {
+		ch->attrs.val.index.bgcolor ^= 0xf;
+		ch->attrs.val.index.fgcolor ^= 0xf;
+	} else if (ch->attrs.type == CHAR_ATTR_RGB) {
+		ch->attrs.val.rgb.fgcolor ^= 0xffffff;
+		ch->attrs.val.rgb.bgcolor ^= 0xffffff;
+	} else if (ch->attrs.type == CHAR_ATTR_STYLE) {
+		/* Don't have a proper inverse for each style */
+		if (ch->attrs.val.style == STYLE_INVERTED)
+			ch->attrs.val.style = STYLE_NORMAL;
+		else
+			ch->attrs.val.style = STYLE_INVERTED;
+	}
+
+	/* Make sure the cell gets updated */
+	ch->flags |= CHAR_FLAG_DIRTY;
+}
+
+/** Undraw mouse pointer. */
+static void pointer_undraw(void)
+{
+	charfield_t *ch;
+	int col, row;
+
+	col = pointer_x / mouse_scale_x;
+	row = pointer_y / mouse_scale_y;
+	if (col < 0 || row < 0 || col >= (int)cols || row >= (int)rows)
+		return;
+
+	ch = chargrid_charfield_at(active_console->frontbuf, col, row);
+	*ch = pointer_bg;
+	ch->flags |= CHAR_FLAG_DIRTY;
+}
+
+/** Queue console event.
+ *
+ * @param cons Console
+ * @param ev Console event
+ */
+static void console_queue_cons_event(console_t *cons, cons_event_t *ev)
+{
+	/* Got key press/release event */
+	cons_event_t *event =
+	    (cons_event_t *) malloc(sizeof(cons_event_t));
+	if (event == NULL)
+		return;
+
+	*event = *ev;
+	link_initialize(&event->link);
+
+	prodcons_produce(&cons->input_pc, &event->link);
 }
 
@@ -252,4 +356,6 @@
     keymod_t mods, char32_t c)
 {
+	cons_event_t event;
+
 	if ((key >= KC_F1) && (key <= KC_F1 + CONSOLE_COUNT) &&
 	    ((mods & KM_CTRL) == 0)) {
@@ -257,25 +363,57 @@
 	} else {
 		/* Got key press/release event */
-		kbd_event_t *event =
-		    (kbd_event_t *) malloc(sizeof(kbd_event_t));
-		if (event == NULL) {
-			return ENOMEM;
-		}
-
-		link_initialize(&event->link);
-		event->type = type;
-		event->key = key;
-		event->mods = mods;
-		event->c = c;
-
-		prodcons_produce(&active_console->input_pc,
-		    &event->link);
-	}
-
-	return EOK;
+		event.type = CEV_KEY;
+
+		event.ev.key.type = type;
+		event.ev.key.key = key;
+		event.ev.key.mods = mods;
+		event.ev.key.c = c;
+
+		console_queue_cons_event(active_console, &event);
+	}
+
+	return EOK;
+}
+
+/** Update pointer position.
+ *
+ * @param new_x New X coordinate (in pixels)
+ * @param new_y New Y coordinate (in pixels)
+ */
+static void pointer_update(int new_x, int new_y)
+{
+	bool upd_pointer;
+
+	/* Make sure coordinates are in range */
+
+	if (new_x < 0)
+		new_x = 0;
+	if (new_x >= (int)cols * mouse_scale_x)
+		new_x = cols * mouse_scale_x - 1;
+	if (new_y < 0)
+		new_y = 0;
+	if (new_y >= (int)rows * mouse_scale_y)
+		new_y = rows * mouse_scale_y - 1;
+
+	/* Determine if pointer moved to a different character cell */
+	upd_pointer = (new_x / mouse_scale_x != pointer_x / mouse_scale_x) ||
+	    (new_y / mouse_scale_y != pointer_y / mouse_scale_y);
+
+	if (upd_pointer)
+		pointer_undraw();
+
+	/* Store new pointer position */
+	pointer_x = new_x;
+	pointer_y = new_y;
+
+	if (upd_pointer) {
+		pointer_draw();
+		cons_update(active_console);
+	}
 }
 
 static errno_t input_ev_move(input_t *input, int dx, int dy)
 {
+	pointer_update(pointer_x + dx, pointer_y + dy);
 	return EOK;
 }
@@ -284,4 +422,5 @@
     unsigned max_x, unsigned max_y)
 {
+	pointer_update(mouse_scale_x * cols * x / max_x, mouse_scale_y * rows * y / max_y);
 	return EOK;
 }
@@ -289,4 +428,13 @@
 static errno_t input_ev_button(input_t *input, int bnum, int bpress)
 {
+	cons_event_t event;
+
+	event.type = CEV_POS;
+	event.ev.pos.type = bpress ? POS_PRESS : POS_RELEASE;
+	event.ev.pos.btn_num = bnum;
+	event.ev.pos.hpos = pointer_x / mouse_scale_x;
+	event.ev.pos.vpos = pointer_y / mouse_scale_y;
+
+	console_queue_cons_event(active_console, &event);
 	return EOK;
 }
@@ -298,4 +446,5 @@
 
 	fibril_mutex_lock(&cons->mtx);
+	pointer_undraw();
 
 	switch (ch) {
@@ -315,4 +464,5 @@
 	}
 
+	pointer_draw();
 	fibril_mutex_unlock(&cons->mtx);
 
@@ -324,5 +474,7 @@
 {
 	fibril_mutex_lock(&cons->mtx);
+	pointer_undraw();
 	chargrid_set_cursor_visibility(cons->frontbuf, visible);
+	pointer_draw();
 	fibril_mutex_unlock(&cons->mtx);
 
@@ -367,9 +519,11 @@
 		if (pos < size) {
 			link_t *link = prodcons_consume(&cons->input_pc);
-			kbd_event_t *event = list_get_instance(link, kbd_event_t, link);
+			cons_event_t *event = list_get_instance(link,
+			    cons_event_t, link);
 
 			/* Accept key presses of printable chars only. */
-			if ((event->type == KEY_PRESS) && (event->c != 0)) {
-				char32_t tmp[2] = { event->c, 0 };
+			if (event->type == CEV_KEY && event->ev.key.type == KEY_PRESS &&
+			    (event->ev.key.c != 0)) {
+				char32_t tmp[2] = { event->ev.key.c, 0 };
 				wstr_to_str(cons->char_remains, UTF8_CHAR_BUFFER_SIZE, tmp);
 				cons->char_remains_len = str_size(cons->char_remains);
@@ -408,5 +562,7 @@
 
 	fibril_mutex_lock(&cons->mtx);
+	pointer_undraw();
 	chargrid_clear(cons->frontbuf);
+	pointer_draw();
 	fibril_mutex_unlock(&cons->mtx);
 
@@ -419,5 +575,7 @@
 
 	fibril_mutex_lock(&cons->mtx);
+	pointer_undraw();
 	chargrid_set_cursor(cons->frontbuf, col, row);
+	pointer_draw();
 	fibril_mutex_unlock(&cons->mtx);
 
@@ -499,11 +657,126 @@
 	console_t *cons = srv_to_console(srv);
 	link_t *link = prodcons_consume(&cons->input_pc);
-	kbd_event_t *kevent = list_get_instance(link, kbd_event_t, link);
-
-	event->type = CEV_KEY;
-	event->ev.key = *kevent;
-
-	free(kevent);
-	return EOK;
+	cons_event_t *cevent = list_get_instance(link, cons_event_t, link);
+
+	*event = *cevent;
+	free(cevent);
+	return EOK;
+}
+
+/** Create shared buffer for efficient rendering.
+ *
+ * @param srv Console server
+ * @param cols Number of columns in buffer
+ * @param rows Number of rows in buffer
+ * @param rbuf Place to store pointer to new sharable buffer
+ *
+ * @return EOK on sucess or an error code
+ */
+static errno_t cons_map(con_srv_t *srv, sysarg_t cols, sysarg_t rows,
+    charfield_t **rbuf)
+{
+	console_t *cons = srv_to_console(srv);
+	void *buf;
+
+	fibril_mutex_lock(&cons->mtx);
+
+	if (cons->ubuf != NULL) {
+		fibril_mutex_unlock(&cons->mtx);
+		return EBUSY;
+	}
+
+	buf = as_area_create(AS_AREA_ANY, cols * rows * sizeof(charfield_t),
+	    AS_AREA_READ | AS_AREA_WRITE | AS_AREA_CACHEABLE, AS_AREA_UNPAGED);
+	if (buf == AS_MAP_FAILED) {
+		fibril_mutex_unlock(&cons->mtx);
+		return ENOMEM;
+	}
+
+	cons->ucols = cols;
+	cons->urows = rows;
+	cons->ubuf = buf;
+	fibril_mutex_unlock(&cons->mtx);
+
+	*rbuf = buf;
+	return EOK;
+}
+
+/** Delete shared buffer.
+ *
+ * @param srv Console server
+ */
+static void cons_unmap(con_srv_t *srv)
+{
+	console_t *cons = srv_to_console(srv);
+	void *buf;
+
+	fibril_mutex_lock(&cons->mtx);
+
+	buf = cons->ubuf;
+	cons->ubuf = NULL;
+
+	if (buf != NULL)
+		as_area_destroy(buf);
+
+	fibril_mutex_unlock(&cons->mtx);
+}
+
+/** Update area of console from shared buffer.
+ *
+ * @param srv Console server
+ * @param c0 Column coordinate of top-left corner (inclusive)
+ * @param r0 Row coordinate of top-left corner (inclusive)
+ * @param c1 Column coordinate of bottom-right corner (exclusive)
+ * @param r1 Row coordinate of bottom-right corner (exclusive)
+ */
+static void cons_buf_update(con_srv_t *srv, sysarg_t c0, sysarg_t r0,
+    sysarg_t c1, sysarg_t r1)
+{
+	console_t *cons = srv_to_console(srv);
+	charfield_t *ch;
+	sysarg_t col, row;
+
+	fibril_mutex_lock(&cons->mtx);
+
+	if (cons->ubuf == NULL) {
+		fibril_mutex_unlock(&cons->mtx);
+		return;
+	}
+
+	/* Make sure we have meaningful coordinates, within bounds */
+
+	if (c1 > cons->ucols)
+		c1 = cons->ucols;
+	if (c1 > cons->cols)
+		c1 = cons->cols;
+	if (c0 >= c1) {
+		fibril_mutex_unlock(&cons->mtx);
+		return;
+	}
+	if (r1 > cons->urows)
+		r1 = cons->urows;
+	if (r1 > cons->rows)
+		r1 = cons->rows;
+	if (r0 >= r1) {
+		fibril_mutex_unlock(&cons->mtx);
+		return;
+	}
+
+	/* Update front buffer from user buffer */
+
+	pointer_undraw();
+
+	for (row = r0; row < r1; row++) {
+		for (col = c0; col < c1; col++) {
+			ch = chargrid_charfield_at(cons->frontbuf, col, row);
+			*ch = cons->ubuf[row * cons->ucols + col];
+		}
+	}
+
+	pointer_draw();
+	fibril_mutex_unlock(&cons->mtx);
+
+	/* Update console */
+	cons_update(cons);
 }
 
@@ -649,4 +922,6 @@
 
 		input_activate(input);
+		active = true;
+		cons_damage(active_console);
 	}
 
Index: uspace/srv/hid/display/client.c
===================================================================
--- uspace/srv/hid/display/client.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/hid/display/client.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -115,7 +115,10 @@
 	seat = ds_display_first_seat(wnd->display);
 	while (seat != NULL) {
-		ds_seat_evac_focus(seat, wnd);
+		ds_seat_evac_wnd_refs(seat, wnd);
 		seat = ds_display_next_seat(seat);
 	}
+
+	/* Make sure no event in the queue is referencing the window */
+	ds_client_purge_window_events(wnd->client, wnd);
 
 	list_remove(&wnd->lcwindows);
@@ -199,4 +202,28 @@
 }
 
+/** Purge events from client event queue referring to a window.
+ *
+ * @param client Client
+ * @param window Window
+ */
+void ds_client_purge_window_events(ds_client_t *client,
+    ds_window_t *window)
+{
+	link_t *cur;
+	link_t *next;
+	ds_window_ev_t *wevent;
+
+	cur = list_first(&client->events);
+	while (cur != NULL) {
+		next = list_next(cur, &client->events);
+		wevent = list_get_instance(cur, ds_window_ev_t, levents);
+
+		if (wevent->window == window)
+			list_remove(cur);
+
+		cur = next;
+	}
+}
+
 /** Post close event to the client's message queue.
  *
Index: uspace/srv/hid/display/client.h
===================================================================
--- uspace/srv/hid/display/client.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/hid/display/client.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -53,4 +53,5 @@
 extern errno_t ds_client_get_event(ds_client_t *, ds_window_t **,
     display_wnd_ev_t *);
+extern void ds_client_purge_window_events(ds_client_t *, ds_window_t *);
 extern errno_t ds_client_post_close_event(ds_client_t *, ds_window_t *);
 extern errno_t ds_client_post_focus_event(ds_client_t *, ds_window_t *);
Index: uspace/srv/hid/display/clonegc.c
===================================================================
--- uspace/srv/hid/display/clonegc.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/hid/display/clonegc.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -44,4 +44,5 @@
 #include "clonegc.h"
 
+static errno_t ds_clonegc_set_clip_rect(void *, gfx_rect_t *);
 static errno_t ds_clonegc_set_color(void *, gfx_color_t *);
 static errno_t ds_clonegc_fill_rect(void *, gfx_rect_t *);
@@ -65,4 +66,5 @@
 
 gfx_context_ops_t ds_clonegc_ops = {
+	.set_clip_rect = ds_clonegc_set_clip_rect,
 	.set_color = ds_clonegc_set_color,
 	.fill_rect = ds_clonegc_fill_rect,
@@ -73,4 +75,29 @@
 };
 
+/** Set clipping rectangle on clone GC.
+ *
+ * @param arg Clone GC
+ * @param rect Rectangle
+ *
+ * @return EOK on success or an error code
+ */
+static errno_t ds_clonegc_set_clip_rect(void *arg, gfx_rect_t *rect)
+{
+	ds_clonegc_t *cgc = (ds_clonegc_t *)arg;
+	ds_clonegc_output_t *output;
+	errno_t rc;
+
+	output = ds_clonegc_first_output(cgc);
+	while (output != NULL) {
+		rc = gfx_set_clip_rect(output->gc, rect);
+		if (rc != EOK)
+			return rc;
+
+		output = ds_clonegc_next_output(output);
+	}
+
+	return EOK;
+}
+
 /** Set color on clone GC.
  *
Index: uspace/srv/hid/display/cursimg.c
===================================================================
--- uspace/srv/hid/display/cursimg.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/hid/display/cursimg.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -137,4 +137,26 @@
 };
 
+static uint8_t ibeam_img[] = {
+	0, 1, 1, 1, 1, 0, 1, 1, 1, 1, 0,
+	1, 2, 2, 2, 2, 1, 2, 2, 2, 2, 1,
+	0, 1, 1, 1, 1, 2, 1, 1, 1, 1, 0,
+	0, 0, 0, 0, 1, 2, 1, 0, 0, 0, 0,
+	0, 0, 0, 0, 1, 2, 1, 0, 0, 0, 0,
+	0, 0, 0, 0, 1, 2, 1, 0, 0, 0, 0,
+	0, 0, 0, 0, 1, 2, 1, 0, 0, 0, 0,
+	0, 0, 0, 0, 1, 2, 1, 0, 0, 0, 0,
+	0, 0, 0, 0, 1, 2, 1, 0, 0, 0, 0,
+	0, 0, 0, 0, 1, 2, 1, 0, 0, 0, 0,
+	0, 0, 0, 0, 1, 2, 1, 0, 0, 0, 0,
+	0, 0, 0, 0, 1, 2, 1, 0, 0, 0, 0,
+	0, 0, 0, 0, 1, 2, 1, 0, 0, 0, 0,
+	0, 0, 0, 0, 1, 2, 1, 0, 0, 0, 0,
+	0, 0, 0, 0, 1, 2, 1, 0, 0, 0, 0,
+	0, 0, 0, 0, 1, 2, 1, 0, 0, 0, 0,
+	0, 1, 1, 1, 1, 2, 1, 1, 1, 1, 0,
+	1, 2, 2, 2, 2, 1, 2, 2, 2, 2, 1,
+	0, 1, 1, 1, 1, 0, 1, 1, 1, 1, 0
+};
+
 ds_cursimg_t ds_cursimg[dcurs_limit] = {
 	{
@@ -157,4 +179,8 @@
 		.rect = { -7, -7, 8, 8 },
 		.image = size_urdl_img
+	},
+	{
+		.rect = { -5, -9, 6, 10 },
+		.image = ibeam_img
 	}
 };
Index: uspace/srv/hid/display/display.c
===================================================================
--- uspace/srv/hid/display/display.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/hid/display/display.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -50,5 +50,11 @@
 
 static gfx_context_t *ds_display_get_unbuf_gc(ds_display_t *);
-static void ds_display_update_cb(void *, gfx_rect_t *);
+static void ds_display_invalidate_cb(void *, gfx_rect_t *);
+static void ds_display_update_cb(void *);
+
+static mem_gc_cb_t ds_display_mem_gc_cb = {
+	.invalidate = ds_display_invalidate_cb,
+	.update = ds_display_update_cb
+};
 
 /** Create display.
@@ -458,6 +464,6 @@
 		goto error;
 
-	rc = mem_gc_create(&disp->rect, &alloc,
-	    ds_display_update_cb, (void *) disp, &disp->bbgc);
+	rc = mem_gc_create(&disp->rect, &alloc, &ds_display_mem_gc_cb,
+	    (void *) disp, &disp->bbgc);
 	if (rc != EOK)
 		goto error;
@@ -732,5 +738,5 @@
 }
 
-/** Display update callback.
+/** Display invalidate callback.
  *
  * Called by backbuffer memory GC when something is rendered into it.
@@ -740,5 +746,5 @@
  * @param rect Rectangle to update
  */
-static void ds_display_update_cb(void *arg, gfx_rect_t *rect)
+static void ds_display_invalidate_cb(void *arg, gfx_rect_t *rect)
 {
 	ds_display_t *disp = (ds_display_t *) arg;
@@ -749,4 +755,15 @@
 }
 
+/** Display update callback.
+ *
+ * @param arg Argument (display cast as void *)
+ */
+static void ds_display_update_cb(void *arg)
+{
+	ds_display_t *disp = (ds_display_t *) arg;
+
+	(void) disp;
+}
+
 /** @}
  */
Index: uspace/srv/hid/display/dsops.c
===================================================================
--- uspace/srv/hid/display/dsops.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/hid/display/dsops.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -48,4 +48,5 @@
 static errno_t disp_window_move_req(void *, sysarg_t, gfx_coord2_t *);
 static errno_t disp_window_move(void *, sysarg_t, gfx_coord2_t *);
+static errno_t disp_window_get_pos(void *, sysarg_t, gfx_coord2_t *);
 static errno_t disp_window_resize_req(void *, sysarg_t,
     display_wnd_rsztype_t, gfx_coord2_t *);
@@ -61,4 +62,5 @@
 	.window_move_req = disp_window_move_req,
 	.window_move = disp_window_move,
+	.window_get_pos = disp_window_get_pos,
 	.window_resize_req = disp_window_resize_req,
 	.window_resize = disp_window_resize,
@@ -73,5 +75,4 @@
 	errno_t rc;
 	ds_client_t *client = (ds_client_t *) arg;
-	ds_seat_t *seat;
 	ds_window_t *wnd;
 
@@ -90,12 +91,4 @@
 	    wnd->id);
 
-	/* XXX All the below should probably be part of ds_window_create() */
-	wnd->dpos.x = ((wnd->id - 1) & 1) * 400;
-	wnd->dpos.y = ((wnd->id - 1) & 2) / 2 * 300;
-
-	seat = ds_display_first_seat(client->display);
-	ds_seat_set_focus(seat, wnd);
-	(void) ds_display_paint(wnd->display, NULL);
-
 	ds_display_unlock(client->display);
 
@@ -118,5 +111,4 @@
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "disp_window_destroy()");
-	ds_client_remove_window(wnd);
 	ds_window_destroy(wnd);
 	ds_display_unlock(client->display);
@@ -163,4 +155,24 @@
 }
 
+static errno_t disp_window_get_pos(void *arg, sysarg_t wnd_id,
+    gfx_coord2_t *pos)
+{
+	ds_client_t *client = (ds_client_t *) arg;
+	ds_window_t *wnd;
+
+	ds_display_lock(client->display);
+
+	wnd = ds_client_find_window(client, wnd_id);
+	if (wnd == NULL) {
+		ds_display_unlock(client->display);
+		return ENOENT;
+	}
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "disp_window_get_pos()");
+	ds_window_get_pos(wnd, pos);
+	ds_display_unlock(client->display);
+	return EOK;
+}
+
 static errno_t disp_window_resize_req(void *arg, sysarg_t wnd_id,
     display_wnd_rsztype_t rsztype, gfx_coord2_t *pos)
Index: uspace/srv/hid/display/main.c
===================================================================
--- uspace/srv/hid/display/main.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/hid/display/main.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -188,5 +188,7 @@
 		display_conn(icall, &srv);
 
+		ds_display_lock(disp);
 		ds_client_destroy(client);
+		ds_display_unlock(disp);
 	} else {
 		/* Window GC connection */
Index: uspace/srv/hid/display/seat.c
===================================================================
--- uspace/srv/hid/display/seat.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/hid/display/seat.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -104,21 +104,44 @@
 		ds_window_bring_to_top(wnd);
 	}
-}
-
-/** Evacuate focus from window.
+
+	/* When focus changes, popup window should be closed */
+	ds_seat_set_popup(seat, NULL);
+}
+
+/** Set seat popup window.
+ *
+ * @param seat Seat
+ * @param wnd Popup window
+ */
+void ds_seat_set_popup(ds_seat_t *seat, ds_window_t *wnd)
+{
+	if (wnd == seat->popup)
+		return;
+
+	if (seat->popup != NULL) {
+		/* Window is no longer the popup window, send close request */
+		ds_client_post_close_event(seat->popup->client,
+		    seat->popup);
+	}
+
+	seat->popup = wnd;
+}
+
+/** Evacuate seat references to window.
  *
  * If seat's focus is @a wnd, it will be set to a different window.
+ * If seat's popup window is @a wnd, it will be set to NULL.
  *
  * @param seat Seat
  * @param wnd Window to evacuate focus from
  */
-void ds_seat_evac_focus(ds_seat_t *seat, ds_window_t *wnd)
+void ds_seat_evac_wnd_refs(ds_seat_t *seat, ds_window_t *wnd)
 {
 	ds_window_t *nwnd;
 
 	if (seat->focus == wnd) {
-		nwnd = ds_display_next_window(wnd);
+		nwnd = ds_display_prev_window(wnd);
 		if (nwnd == NULL)
-			nwnd = ds_display_first_window(wnd->display);
+			nwnd = ds_display_last_window(wnd->display);
 		if (nwnd == wnd)
 			nwnd = NULL;
@@ -126,4 +149,28 @@
 		ds_seat_set_focus(seat, nwnd);
 	}
+
+	if (seat->popup == wnd)
+		ds_seat_set_popup(seat, NULL);
+}
+
+/** Switch focus to another window.
+ *
+ * @param seat Seat
+ * @param wnd Window to evacuate focus from
+ */
+void ds_seat_switch_focus(ds_seat_t *seat)
+{
+	ds_window_t *nwnd;
+
+	if (seat->focus != NULL)
+		nwnd = ds_display_prev_window(seat->focus);
+	else
+		nwnd = NULL;
+
+	if (nwnd == NULL)
+		nwnd = ds_display_last_window(seat->display);
+
+	if (nwnd != NULL)
+		ds_seat_set_focus(seat, nwnd);
 }
 
@@ -143,9 +190,12 @@
 	if (event->type == KEY_PRESS && alt_or_shift && event->key == KC_TAB) {
 		/* On Alt-Tab or Shift-Tab, switch focus to next window */
-		ds_seat_evac_focus(seat, seat->focus);
+		ds_seat_switch_focus(seat);
 		return EOK;
 	}
 
-	dwindow = seat->focus;
+	dwindow = seat->popup;
+	if (dwindow == NULL)
+		dwindow = seat->focus;
+
 	if (dwindow == NULL)
 		return EOK;
@@ -307,5 +357,5 @@
 	/* Focus window on button press */
 	if (event->type == PTD_PRESS && event->btn_num == 1) {
-		if (wnd != NULL) {
+		if (wnd != NULL && (wnd->flags & wndf_popup) == 0) {
 			ds_seat_set_focus(seat, wnd);
 		}
@@ -390,5 +440,18 @@
 	wnd = ds_display_window_by_pos(seat->display, &seat->pntpos);
 
-	if (seat->focus != wnd) {
+	/* Click outside popup window */
+	if (event->type == POS_PRESS && wnd != seat->popup) {
+		/* Close popup window */
+		ds_seat_set_popup(seat, NULL);
+	}
+
+	/* Deliver event to popup window. */
+	if (seat->popup != NULL) {
+		rc = ds_window_post_pos_event(seat->popup, event);
+		if (rc != EOK)
+			return rc;
+	}
+
+	if (seat->focus != wnd && seat->focus != NULL) {
 		rc = ds_window_post_pos_event(seat->focus, event);
 		if (rc != EOK)
@@ -404,7 +467,13 @@
 		ds_seat_set_client_cursor(seat, wnd->cursor);
 
-		rc = ds_window_post_pos_event(wnd, event);
-		if (rc != EOK)
-			return rc;
+		/*
+		 * Only deliver event if we didn't already deliver it
+		 * to the same window above.
+		 */
+		if (wnd != seat->popup) {
+			rc = ds_window_post_pos_event(wnd, event);
+			if (rc != EOK)
+				return rc;
+		}
 	} else {
 		/* Not over a window */
Index: uspace/srv/hid/display/seat.h
===================================================================
--- uspace/srv/hid/display/seat.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/hid/display/seat.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -49,5 +49,7 @@
 extern void ds_seat_destroy(ds_seat_t *);
 extern void ds_seat_set_focus(ds_seat_t *, ds_window_t *);
-extern void ds_seat_evac_focus(ds_seat_t *, ds_window_t *);
+extern void ds_seat_set_popup(ds_seat_t *, ds_window_t *);
+extern void ds_seat_evac_wnd_refs(ds_seat_t *, ds_window_t *);
+extern void ds_seat_switch_focus(ds_seat_t *);
 extern errno_t ds_seat_post_kbd_event(ds_seat_t *, kbd_event_t *);
 extern errno_t ds_seat_post_ptd_event(ds_seat_t *, ptd_event_t *);
